package com.codigoparallevar.minicards;

import android.content.Context;
import android.content.SharedPreferences;

import static android.content.Context.MODE_PRIVATE;

public class ConfigManager {
    private final Context context;
    private static final String PREFERENCES_NAME = "MINICARDS_PREFERENCES";
    private static final String TOKEN_KEY = "PROGRAMAKER_API_TOKEN";
    private static final String BRIDGE_ID_KEY = "PROGRAMAKER_BRIDGE_ID";

    public ConfigManager(Context ctx) {
        this.context = ctx;
    }

    public void setToken(String token) {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        SharedPreferences.Editor edit = preferences.edit();

        edit.putString(TOKEN_KEY, token);
        edit.apply();
    }

    public String getToken() {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        return preferences.getString(TOKEN_KEY, null);
    }

    public void removeBridgeId() {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        SharedPreferences.Editor edit = preferences.edit();

        if (preferences.contains(BRIDGE_ID_KEY)) {
            edit.remove(BRIDGE_ID_KEY).apply();
        }
    }

    public void setBridgeId(String bridgeId) {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        SharedPreferences.Editor edit = preferences.edit();

        edit.putString(BRIDGE_ID_KEY, bridgeId);
        edit.commit();
    }

    public String getBridgeId() {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        return preferences.getString(BRIDGE_ID_KEY, null);
    }
}
