package com.codigoparallevar.minicards.bridge;

import android.content.Context;
import android.provider.Settings;

import com.programaker.bridge.ProgramakerBridge;
import com.programaker.bridge.ProgramakerBridgeConfiguration;

import java.util.Collections;

public class ProgramakerAndroidBridge {
    private static final String LogTag = "PM Android Bridge";
    private ProgramakerBridge bridgeRunner = null;

    // Static
    public static ProgramakerAndroidBridge configure(Context ctx, String userId, String bridgeId) {
        return new ProgramakerAndroidBridge(ctx, userId, bridgeId);
    }

    public static String GetBridgeName(Context ctx) {
        String deviceName = Settings.Secure.getString(ctx.getContentResolver(), "bluetooth_name");
        String serviceName = "MiniCards on " + deviceName;
        return serviceName;
    }

//    public static ProgramakerBridgeConfiguration GetConfiguration(Context ctx) {
//        List<ProgramakerBridgeConfigurationBlock> blocks = new LinkedList<>();
//        return new ProgramakerBridgeConfiguration(serviceName, blocks);
//    }
    // Builder

    private final Context ctx;
    private final String userId;
    private final String bridgeId;

    private ProgramakerAndroidBridge(Context ctx, String userId, String bridgeId) {
        this.ctx = ctx;
        this.userId = userId;
        this.bridgeId = bridgeId;
    }

    public void start(Runnable onComplete) {
        ProgramakerBridgeConfiguration configuration = new ProgramakerBridgeConfiguration(
                ProgramakerAndroidBridge.GetBridgeName(this.ctx),
                Collections.emptyList()
        );

        this.bridgeRunner = new ProgramakerBridge(this.bridgeId, this.userId, configuration, onComplete);
        this.bridgeRunner.run();
    }

}
